Loading...
Searching...
No Matches
libavdevice

Special devices muxing/demuxing library. More...

## Files

file | avdevice.h
| Main libavdevice API header.
file | version.h
| Libavdevice version macros.
file | version_major.h
| Libavdevice version macros.

## Data Structures

struct | AVDeviceRect
struct | AVDeviceInfo
| Structure describes basic parameters of the device. More...
struct | AVDeviceInfoList
| List of devices. More...

## Enumerations

enum

AVAppToDevMessageType {
AV_APP_TO_DEV_NONE = MKBETAG('N','O','N','E') , AV_APP_TO_DEV_WINDOW_SIZE = MKBETAG('G','E','O','M') , AV_APP_TO_DEV_WINDOW_REPAINT = MKBETAG('R','E','P','A') , AV_APP_TO_DEV_PAUSE = MKBETAG('P', 'A', 'U', ' ') ,
AV_APP_TO_DEV_PLAY = MKBETAG('P', 'L', 'A', 'Y') , AV_APP_TO_DEV_TOGGLE_PAUSE = MKBETAG('P', 'A', 'U', 'T') , AV_APP_TO_DEV_SET_VOLUME = MKBETAG('S', 'V', 'O', 'L') , AV_APP_TO_DEV_MUTE = MKBETAG(' ', 'M', 'U', 'T') ,
AV_APP_TO_DEV_UNMUTE = MKBETAG('U', 'M', 'U', 'T') , AV_APP_TO_DEV_TOGGLE_MUTE = MKBETAG('T', 'M', 'U', 'T') , AV_APP_TO_DEV_GET_VOLUME = MKBETAG('G', 'V', 'O', 'L') , AV_APP_TO_DEV_GET_MUTE = MKBETAG('G', 'M', 'U', 'T')
}

| Message types used by avdevice_app_to_dev_control_message(). More...

enum

AVDevToAppMessageType {
AV_DEV_TO_APP_NONE = MKBETAG('N','O','N','E') , AV_DEV_TO_APP_CREATE_WINDOW_BUFFER = MKBETAG('B','C','R','E') , AV_DEV_TO_APP_PREPARE_WINDOW_BUFFER = MKBETAG('B','P','R','E') , AV_DEV_TO_APP_DISPLAY_WINDOW_BUFFER = MKBETAG('B','D','I','S') ,
AV_DEV_TO_APP_DESTROY_WINDOW_BUFFER = MKBETAG('B','D','E','S') , AV_DEV_TO_APP_BUFFER_OVERFLOW = MKBETAG('B','O','F','L') , AV_DEV_TO_APP_BUFFER_UNDERFLOW = MKBETAG('B','U','F','L') , AV_DEV_TO_APP_BUFFER_READABLE = MKBETAG('B','R','D',' ') ,
AV_DEV_TO_APP_BUFFER_WRITABLE = MKBETAG('B','W','R',' ') , AV_DEV_TO_APP_MUTE_STATE_CHANGED = MKBETAG('C','M','U','T') , AV_DEV_TO_APP_VOLUME_LEVEL_CHANGED = MKBETAG('C','V','O','L')
}

| Message types used by avdevice_dev_to_app_control_message(). More...

## Functions

unsigned | avdevice_version (void)
| Return the LIBAVDEVICE_VERSION_INT constant.
const char * | avdevice_configuration (void)
| Return the libavdevice build-time configuration.
const char * | avdevice_license (void)
| Return the libavdevice license.
void | avdevice_register_all (void)
| Initialize libavdevice and register all the input and output devices.
const AVInputFormat * | av_input_audio_device_next (const AVInputFormat *d)
| Audio input devices iterator.
const AVInputFormat * | av_input_video_device_next (const AVInputFormat *d)
| Video input devices iterator.
const AVOutputFormat * | av_output_audio_device_next (const AVOutputFormat *d)
| Audio output devices iterator.
const AVOutputFormat * | av_output_video_device_next (const AVOutputFormat *d)
| Video output devices iterator.
int | avdevice_app_to_dev_control_message (struct AVFormatContext *s, enum AVAppToDevMessageType type, void *data, size_t data_size)
| Send control message from application to device.
int | avdevice_dev_to_app_control_message (struct AVFormatContext *s, enum AVDevToAppMessageType type, void *data, size_t data_size)
| Send control message from device to application.
int | avdevice_list_devices (struct AVFormatContext *s, AVDeviceInfoList **device_list)
| List devices.
void | avdevice_free_list_devices (AVDeviceInfoList **device_list)
| Convenient function to free result of avdevice_list_devices().
int | avdevice_list_input_sources (const AVInputFormat *device, const char *device_name, AVDictionary *device_options, AVDeviceInfoList **device_list)
| List devices.
int | avdevice_list_output_sinks (const AVOutputFormat *device, const char *device_name, AVDictionary *device_options, AVDeviceInfoList **device_list)

## Detailed Description

Special devices muxing/demuxing library.

Libavdevice is a complementary library to libavformat. It provides various "special" platform-specific muxers and demuxers, e.g. for grabbing devices, audio capture and playback etc. As a consequence, the (de)muxers in libavdevice are of the AVFMT_NOFILE type (they use their own I/O functions). The filename passed to avformat_open_input() often does not refer to an actually existing file, but has some special device-specific meaning - e.g. for xcbgrab it is the display name.

To use libavdevice, simply call avdevice_register_all() to register all compiled muxers and demuxers. They all use standard libavformat API.

## Enumeration Type Documentation

## AVAppToDevMessageType

enum AVAppToDevMessageType

Message types used by avdevice_app_to_dev_control_message().

Enumerator
AV_APP_TO_DEV_NONE | Dummy message.
AV_APP_TO_DEV_WINDOW_SIZE | Window size change message. Message is sent to the device every time the application changes the size of the window device renders to. Message should also be sent right after window is created. data: AVDeviceRect: new window size.
AV_APP_TO_DEV_WINDOW_REPAINT | Repaint request message. Message is sent to the device when window has to be repainted. data: AVDeviceRect: area required to be repainted. NULL: whole area is required to be repainted.
AV_APP_TO_DEV_PAUSE | Request pause/play. Application requests pause/unpause playback. Mostly usable with devices that have internal buffer. By default devices are not paused. data: NULL
AV_APP_TO_DEV_PLAY |
AV_APP_TO_DEV_TOGGLE_PAUSE |
AV_APP_TO_DEV_SET_VOLUME | Volume control message. Set volume level. It may be device-dependent if volume is changed per stream or system wide. Per stream volume change is expected when possible. data: double: new volume with range of 0.0 - 1.0.
AV_APP_TO_DEV_MUTE | Mute control messages. Change mute state. It may be device-dependent if mute status is changed per stream or system wide. Per stream mute status change is expected when possible. data: NULL.
AV_APP_TO_DEV_UNMUTE |
AV_APP_TO_DEV_TOGGLE_MUTE |
AV_APP_TO_DEV_GET_VOLUME | Get volume/mute messages. Force the device to send AV_DEV_TO_APP_VOLUME_LEVEL_CHANGED or AV_DEV_TO_APP_MUTE_STATE_CHANGED command respectively. data: NULL.
AV_APP_TO_DEV_GET_MUTE |

Definition at line 125 of file avdevice.h.

## AVDevToAppMessageType

enum AVDevToAppMessageType

Message types used by avdevice_dev_to_app_control_message().

Enumerator
AV_DEV_TO_APP_NONE | Dummy message.

AV_DEV_TO_APP_CREATE_WINDOW_BUFFER

Create window buffer message.

Device requests to create a window buffer. Exact meaning is device- and application-dependent. Message is sent before rendering first frame and all one-shot initializations should be done here. Application is allowed to ignore preferred window buffer size.

Note
  : Application is obligated to inform about window buffer size with AV_APP_TO_DEV_WINDOW_SIZE message.

data: AVDeviceRect: preferred size of the window buffer. NULL: no preferred size of the window buffer.

AV_DEV_TO_APP_PREPARE_WINDOW_BUFFER | Prepare window buffer message. Device requests to prepare a window buffer for rendering. Exact meaning is device- and application-dependent. Message is sent before rendering of each frame. data: NULL.
AV_DEV_TO_APP_DISPLAY_WINDOW_BUFFER | Display window buffer message. Device requests to display a window buffer. Message is sent when new frame is ready to be displayed. Usually buffers need to be swapped in handler of this message. data: NULL.
AV_DEV_TO_APP_DESTROY_WINDOW_BUFFER | Destroy window buffer message. Device requests to destroy a window buffer. Message is sent when device is about to be destroyed and window buffer is not required anymore. data: NULL.
AV_DEV_TO_APP_BUFFER_OVERFLOW | Buffer fullness status messages. Device signals buffer overflow/underflow. data: NULL.
AV_DEV_TO_APP_BUFFER_UNDERFLOW |

AV_DEV_TO_APP_BUFFER_READABLE

Buffer readable/writable.

Device informs that buffer is readable/writable. When possible, device informs how many bytes can be read/write.

Warning
  Device may not inform when number of bytes than can be read/write changes.

data: int64_t: amount of bytes available to read/write. NULL: amount of bytes available to read/write is not known.

AV_DEV_TO_APP_BUFFER_WRITABLE |
AV_DEV_TO_APP_MUTE_STATE_CHANGED | Mute state change message. Device informs that mute state has changed. data: int: 0 for not muted state, non-zero for muted state.
AV_DEV_TO_APP_VOLUME_LEVEL_CHANGED | Volume level change message. Device informs that volume level has changed. data: double: new volume with range of 0.0 - 1.0.

Definition at line 204 of file avdevice.h.

## Function Documentation

## avdevice_version()

unsigned avdevice_version | ( | void |  | ) |

Return the LIBAVDEVICE_VERSION_INT constant.

## avdevice_configuration()

const char * avdevice_configuration | ( | void |  | ) |

Return the libavdevice build-time configuration.

## avdevice_license()

const char * avdevice_license | ( | void |  | ) |

Return the libavdevice license.

## avdevice_register_all()

void avdevice_register_all | ( | void |  | ) |

Initialize libavdevice and register all the input and output devices.

## av_input_audio_device_next()

const AVInputFormat * av_input_audio_device_next | ( | const AVInputFormat * | d | ) |

Audio input devices iterator.

If d is NULL, returns the first registered input audio/video device, if d is non-NULL, returns the next registered input audio/video device after d or NULL if d is the last one.

## av_input_video_device_next()

const AVInputFormat * av_input_video_device_next | ( | const AVInputFormat * | d | ) |

Video input devices iterator.

If d is NULL, returns the first registered input audio/video device, if d is non-NULL, returns the next registered input audio/video device after d or NULL if d is the last one.

## av_output_audio_device_next()

const AVOutputFormat * av_output_audio_device_next | ( | const AVOutputFormat * | d | ) |

Audio output devices iterator.

If d is NULL, returns the first registered output audio/video device, if d is non-NULL, returns the next registered output audio/video device after d or NULL if d is the last one.

## av_output_video_device_next()

const AVOutputFormat * av_output_video_device_next | ( | const AVOutputFormat * | d | ) |

Video output devices iterator.

If d is NULL, returns the first registered output audio/video device, if d is non-NULL, returns the next registered output audio/video device after d or NULL if d is the last one.

## avdevice_app_to_dev_control_message()

int avdevice_app_to_dev_control_message | ( | struct AVFormatContext * | s,
|  | enum AVAppToDevMessageType | type,
|  | void * | data,
|  | size_t | data_size
| ) |  |

Send control message from application to device.

Parameters

  s | device context.
  type | message type.
  data | message data. Exact type depends on message type.
  data_size | size of message data.

Returns
  >= 0 on success, negative on error. AVERROR(ENOSYS) when device doesn't implement handler of the message.

## avdevice_dev_to_app_control_message()

int avdevice_dev_to_app_control_message | ( | struct AVFormatContext * | s,
|  | enum AVDevToAppMessageType | type,
|  | void * | data,
|  | size_t | data_size
| ) |  |

Send control message from device to application.

Parameters

  s | device context.
  type | message type.
  data | message data. Can be NULL.
  data_size | size of message data.

Returns
  >= 0 on success, negative on error. AVERROR(ENOSYS) when application doesn't implement handler of the message.

## avdevice_list_devices()

int avdevice_list_devices | ( | struct AVFormatContext * | s,
|  | AVDeviceInfoList ** | device_list
| ) |  |

List devices.

Returns available device names and their parameters.

Note
  : Some devices may accept system-dependent device names that cannot be autodetected. The list returned by this function cannot be assumed to be always completed.

Parameters

  | s | device context.
  [out] | device_list | list of autodetected devices.

Returns
  count of autodetected devices, negative on error.

## avdevice_free_list_devices()

void avdevice_free_list_devices | ( | AVDeviceInfoList ** | device_list | ) |

Convenient function to free result of avdevice_list_devices().

Parameters

  device_list | device list to be freed.

## avdevice_list_input_sources()

int avdevice_list_input_sources | ( | const AVInputFormat * | device,
|  | const char * | device_name,
|  | AVDictionary * | device_options,
|  | AVDeviceInfoList ** | device_list
| ) |  |

List devices.

Returns available device names and their parameters. These are convinient wrappers for avdevice_list_devices(). Device context is allocated and deallocated internally.

Parameters

  | device | device format. May be NULL if device name is set.
  | device_name | device name. May be NULL if device format is set.
  | device_options | An AVDictionary filled with device-private options. May be NULL. The same options must be passed later to avformat_write_header() for output devices or avformat_open_input() for input devices, or at any other place that affects device-private options.
  [out] | device_list | list of autodetected devices

Returns
  count of autodetected devices, negative on error.

Note
  device argument takes precedence over device_name when both are set.

## avdevice_list_output_sinks()

int avdevice_list_output_sinks | ( | const AVOutputFormat * | device,
|  | const char * | device_name,
|  | AVDictionary * | device_options,
|  | AVDeviceInfoList ** | device_list
| ) |  |